local SKIN = "leknux"

local function FindGhostTargets(player)
	local closestmo = nil
	local maxdist = 2048*FRACUNIT
	local mindist = 150*FRACUNIT
	local span = ANGLE_90
	local dist = 0
	local closestdist = 0
	local table = {}
	
	for mo in mobjs.iterate()
		if (mo.flags & MF_NOCLIPTHING) then continue end
		if (mo.health <= 0) then continue end
		
		if not (mo.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR) and (mo.flags & MF_SHOOTABLE)) then continue end
		
		if (mo == player.mo) then continue end
		if (mo.flags2 & MF2_FRET) then continue end
		
			
		local zdist = (player.mo.z+player.mo.height/2) - (mo.z+mo.height/2)
		dist = P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y)
		if (abs(R_PointToAngle(mo.x, mo.y) - player.mo.angle) > ANGLE_45) then continue end
		
		dist = P_AproxDistance(dist, zdist)
		if (dist > maxdist) then continue end
		if (dist < mindist) then continue end
		
		if (player.mo.flags2 & MF2_TWOD) and (abs(player.mo.y-mo.y) > player.mo.radius) then continue end
		if mo.player and mo.player.valid
			local p = mo.player
			if p and p.valid
			and p.playerstate == PST_LIVE
			and p.powers[pw_carry] != CR_NIGHTSMODE
			and not p.spectator
				if not mo
					return true
				end
				if (gametyperules & GTR_FRIENDLYFIRE)
				or friendlyfire
					return true
				else
					if (gametyperules & GTR_FRIENDLY)
						return false
					else
						if player and player.valid
							if (gametyperules & GTR_TEAMS)
								if player.ctfteam == p.ctfteam
									return false
								else
									return true
								end
							else
								return true
							end
						else
							return true
						end
					end
				end
			end
		end
		--if (closestmo and dist > closestdist) then continue end
		
		if not P_CheckSight(player.mo, mo) then continue end
		
		if table
		and not table[#table+1]
		and #table <= player.ghbag
			table[#table+1] = mo
		end
		
		closestmo = mo
		closestdist = dist
	end
	return table
end

local function DoCrouchRoll(player)
	local cmdang = player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove<<16)
	local momang = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
	if (player.cmd.forwardmove or player.cmd.sidemove)
		if abs(momang-cmdang) <= ANGLE_45+ANG30
			return true
		end
	end
	return false
end

local function IsInZ(mobj, mo)
	if mo.z > (mobj.z+mobj.height)
		return
	end
	if (mobj.z-mobj.height) > (mo.z+mo.height)
		return
	end
	return true
end

addHook("PreThinkFrame", do
	for player in players.iterate()
		if player.valid and player.playerstate == PST_LIVE
		and not player.spectator and player.powers[pw_carry] != CR_NIGHTSMODE
		and player.mo.skin == SKIN
			if (player.nocrouch or player.dontstopspin)
			and player.extrabutton
			and player.cmd.buttons & player.extrabutton
				player.cmd.buttons = $&~(player.extrabutton)
			end
		end
	end
end)

local function CheckDig(player)
	local darover = 0
	local roverdig = 0
	local roversurf = 0
	local infodig = {}
	local candig = false
	if P_MobjFlip(player.mo) == 1
		if player.mo.floorrover
			darover = player.mo.floorrover
			roverdig = player.mo.floorrover.topheight
			roversurf = player.mo.floorrover.bottomheight
			candig = true
		end
	else
		if player.mo.ceilingrover
			darover = player.mo.ceilingrover
			roverdig = player.mo.ceilingrover.bottomheight
			roversurf = player.mo.ceilingrover.topheight
			candig = true
		end
	end
	if candig
		local check = P_SpawnMobj(player.mo.x, player.mo.y, roversurf, MT_THOK)
		check.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
		check.flags2 = $|MF2_DONTDRAW
		check.fuse = 1
		check.tics = 1
		check.radius = player.mo.radius
		check.height = player.mo.height
		if P_TryMove(check, check.x, check.y, false)
		and P_CheckPosition(player.mo, check.x, check.y, roversurf)
		and (check.ceilingz-check.floorz) > skins[player.mo.skin].height
		and check.subsector and check.subsector.valid
		and check.subsector.sector and check.subsector.sector.valid
		and R_PointInSubsectorOrNil(check.x, check.y)
			candig = true
		else
			candig = false
		end
	end
	infodig.surf = roversurf
	infodig.dig = roverdig
	infodig.rover = darover
	infodig.candig = candig
	return infodig
end

local function CheckDigWall(mo, pmo)
	if P_TryMove(mo, mo.x, mo.y)
	and P_CheckPosition(pmo, mo.x, mo.y, mo.z)
	and (mo.ceilingz-mo.floorz) > pmo.height
	and mo.subsector and mo.subsector.valid
	and mo.subsector.sector and mo.subsector.sector.valid
	and R_PointInSubsectorOrNil(mo.x, mo.y)
	and pmo.z+pmo.height < mo.ceilingz
	and pmo.z > mo.floorz
		return true
	end
	return false
end

local function CanUnflip(player) --False - unflip, True - stay flipped.
	if player.dotheflip
		if player.pflags & PF_JUMPED
			if not player.dontunflip
				return true
			end
		else
			if not player.unfliptrue
				return true
			end
		end
	end
	return false
end

local function PunchEffects(player)
	local momang = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
	local addx1 = P_ReturnThrustX(nil, momang, player.mo.radius*2)
	local addy1 = P_ReturnThrustY(nil, momang, player.mo.radius*2)
	
	if not (leveltime&4)
		local daheg = 0
		if P_MobjFlip(player.mo) == -1
			daheg = -player.mo.height/2
		end
		local dash = P_SpawnMobjFromMobj(player.mo, 0, 0, daheg, MT_FACESTABBERSPEAR)
		dash.flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT
		dash.fuse = 5
		dash.tics = 5
		dash.colorized = true
		dash.angle = player.drawangle+ANGLE_90
		dash.scale = FRACUNIT/3*2
		dash.destscale = FRACUNIT
		dash.color = player.mo.color
		dash.blendmode = AST_OVERLAY
	end
	
		local cen = P_SpawnMobjFromMobj(player.mo, addx1, addy1, 0, MT_THOK)
		cen.tics = 10
		cen.fuse = 10
		cen.destscale = FRACUNIT*2
		cen.scalespeed = FRACUNIT/10
		//cen.renderflags = $|RF_PAPERSPRITE
		cen.angle = player.drawangle
		cen.color = player.mo.color
		cen.blendmode = AST_ADD
end

local function GhostThink(mo)
	if mo and mo.valid
	and mo.auragh
	and mo.type == MT_GHOST
		if mo.target and mo.target.valid
		and mo.target.player and mo.target.player.valid
		and mo.target.player.playerstate == PST_LIVE
			A_CapeChase(mo, 0)
			local mobj = mo.target
			mo.sprite = mobj.sprite
			mo.sprite2 = mobj.sprite2
			mo.frame = mobj.frame
			mo.frame = $&~FF_TRANSMASK
			mo.frame = $|tr_trans70<<FF_TRANSSHIFT
			mo.blendmode = AST_ADD
			mo.skin = mobj.skin
			mo.tics = mobj.tics
			mo.flags2 = mobj.flags2
			mo.eflags = mobj.eflags
		end
	end
end
addHook("ThinkFrame", do
	for mo in mobjs.iterate()
		if mo and mo.valid
		and mo.auragh
		and mo.type == MT_GHOST
			GhostThink(mo)
		end
	end
end)

/*addHook("ShieldSpecial", function(player)
	if player.valid and player.playerstate == PST_LIVE
	and not player.spectator and player.powers[pw_carry] != CR_NIGHTSMODE
	and player.mo.skin == SKIN
		if player.holdingrock
		or player.crouching
		or player.attacking
			return true
		end
	end
end)*/

rawset(_G, "P_ParabolicMove", function(mo, px, py, pz, speed) //Arrow movement func
	local dx = px - mo.x
	local dy = py - mo.y
	local dz = pz - mo.z
	local dh = P_AproxDistance(dx, dy)
	local c = FixedDiv(1+dx, 1+dh)
	local s = FixedDiv(1+dy, 1+dh)
	local fixConst = FixedDiv(1+speed, 1+gravity)
	mo.momx = FixedMul(FixedMul(c, speed), mo.scale)
	mo.momy = FixedMul(FixedMul(s, speed), mo.scale)
	mo.momz = FixedMul((FixedDiv(1+dh, 2*(1+fixConst)) + FixedDiv(1+dz, 1+FixedDiv(1+dh, (1+fixConst)/2))), mo.scale)
end)

rawset(_G, "P_FlyTo", function(mo, fx, fy, fz, sped, addques)
	if mo.valid
		local flyto = P_AproxDistance(P_AproxDistance(fx - mo.x, fy - mo.y), fz - mo.z)
		if flyto < 1
			flyto = 1
		end
		local anglesucc = R_PointToAngle2(mo.x, mo.y, fx, fy)
		
		if addques
			mo.momx = $ + FixedMul(FixedDiv(fx - mo.x, flyto), sped)
			mo.momy = $ + FixedMul(FixedDiv(fy - mo.y, flyto), sped)
			mo.momz = $ + FixedMul(FixedDiv(fz - mo.z, flyto), sped)
		else
			mo.momx = FixedMul(FixedDiv(fx - mo.x, flyto), sped)
			mo.momy = FixedMul(FixedDiv(fy - mo.y, flyto), sped)
			mo.momz = FixedMul(FixedDiv(fz - mo.z, flyto), sped)
		end	
	end	
end) 

local function DoTrick(player)
	player.starttrick = 0
	if player.trickcombo
		player.trickcombo = $ + 1
	else
		player.trickcombo = 1
	end
	local rantrick = {SPR2_SPNG,SPR2_ROLL,SPR2_GLID,SPR2_LAND,SPR2_SPIN,SPR2_WALK,SPR2_RIDE,SPR2_EDGE,SPR2_GASP,SPR2_PAIN}
	local ranframes = {[SPR2_PAIN] = 1,[SPR2_GASP] = 1,[SPR2_SPNG] = 1,[SPR2_ROLL] = -1,[SPR2_GLID] = 1,
		[SPR2_LAND] = 1,[SPR2_SPIN] = -1,[SPR2_WALK] = 8,[SPR2_RIDE] = 1,[SPR2_EDGE] = -1}
	local fincd = 5-(player.trickcombo/5)
	if fincd < 1
		fincd = 1
	end
	player.trickcd = fincd
	S_StartSound(player.mo, sfx_kc48)
			
	if (player.mo.eflags & MFE_UNDERWATER)
		P_SetObjectMomZ(player.mo, (-P_GetMobjGravity(player.mo)/8)*P_MobjFlip(player.mo), true)
	else
		P_SetObjectMomZ(player.mo, (-P_GetMobjGravity(player.mo)/4)*P_MobjFlip(player.mo), true)
	end
			
	local trickstatefr = rantrick[P_RandomRange(1, #rantrick)]
	player.mo.state = S_KNUX_TRICK
	player.mo.sprite2 = trickstatefr
	player.trickstate2 = trickstatefr
	if ranframes and ranframes[player.mo.sprite2]
		if ranframes[player.mo.sprite2] == -1
			player.stopanim = -1
			player.mo.frame = 0
		elseif ranframes[player.mo.sprite2] > 0
			if ranframes[player.mo.sprite2] > 1
				player.stopanim = P_RandomRange(1, ranframes[player.mo.sprite2])
				player.mo.frame = player.stopanim-1
			else
				player.stopanim = 1
				player.mo.frame = 0
			end
		end
		player.mo.tics = TICRATE
		player.trickanim = TICRATE
	end
	
	if (gametyperules & GTR_FRIENDLY)
		P_AddPlayerScore(player, 10) --Small amount because you can spam this very easily
	end
	player.drawangle = P_RandomRange(0, 360)*ANG1
	if P_RandomRange(1, 2) == 1
		player.rotang = -1
	else
		player.rotang = 1
	end
	local tricksc = player.trickcombo
	if player.trickcombo > TICRATE
		tricksc = TICRATE
	end
	for i = 1, tricksc
		local addr = P_RandomRange(0, player.mo.radius>>FRACBITS)<<FRACBITS
		local adda = P_RandomRange(0, 360)*ANG1
		local addx = P_ReturnThrustX(nil, adda, addr)
		local addy = P_ReturnThrustY(nil, adda, addr)
		local addz = P_RandomRange(0, player.mo.height>>FRACBITS)<<FRACBITS
		local s = P_SpawnMobjFromMobj(player.mo, addx, addy, addz, MT_THOK)
		s.state = S_NIGHTSPARKLE1
		s.tics = 15
		s.fuse = 15
		s.color = player.mo.color
		s.colorized = true
		s.blendmode = AST_ADD
		s.momx = player.mo.momx
		s.momy = player.mo.momy
		s.momz = player.mo.momz
		local mx = player.mo.x
		local my = player.mo.y
		local mz = player.mo.z+player.mo.height/2
		local aprx = P_AproxDistance(P_AproxDistance(mx-s.x,my-s.y),mz-s.z)
		P_FlyTo(s, player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, -aprx/5, true)
	end
end

local function CheckAndCrumble(mo, sec)
	for fof in sec.ffloors()
		if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
		if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
		if mo.z + mo.height < fof.bottomheight continue end -- Are we too low?
		if mo.z-mo.height > fof.topheight continue end -- Are we too high?

		-- Check for whatever else you may want to    

		EV_CrumbleChain(fof) -- Crumble
	end
end

addHook("MobjLineCollide", function(mo, line)
	if mo and mo.valid
	and mo.player and mo.player.valid
	and mo.player.playerstate == PST_LIVE
	and mo.skin == SKIN
	and mo.player.groundjump
		for _, sec in ipairs({line.frontsector, line.backsector})
			CheckAndCrumble(mo, sec)
		end
	end
end)

local SEARCHTIME = TICRATE/2*3

addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == SKIN
		if player.extrabutton == nil
			player.extrabutton = BT_CUSTOM1
			local file = io.openlocal("client/knuxconfig.cfg", "r")
			if file //I/O is pretty weird. And some people made a Gameboy emulator with it
				local readresult = file:read("*l")
				player.extrabutton = readresult
				file:close()
			end
		end
		if player.tricksenabled == nil
			player.tricksenabled = true
			local file = io.openlocal("client/knuxconfig2.cfg", "r")
			if file //I/O is pretty weird. And some people made a Gameboy emulator with it
				local readresult = file:read("*l")
				player.tricksenabled = readresult
				file:close()
			end
		end
		if player.trickstype == nil
			player.trickstype = "ledges"
			local file = io.openlocal("client/knuxconfig3.cfg", "r")
			if file //I/O is pretty weird. And some people made a Gameboy emulator with it
				local readresult = file:read("*l")
				player.trickstype = readresult
				file:close()
			end
		end
		player.ghbag = $ or 0
		if not player.ptargets
			player.ptargets = {}
		end
		if player.ptargets
			for i,k in pairs(player.ptargets)
				if player.ptargets[i] and player.ptargets[i].valid
					if player.ptargets[i].health
						P_SpawnLockOn(player, player.ptargets[i], S_LOCKON1)
					else
						player.ptargets[i] = nil
					end
				end
			end
		end
		if player.ghbag
			local levang = (player.realtime%360)*ANG1
			for i = 1, player.ghbag
				local addr = FixedMul(player.mo.radius/8, cos(levang))
				
				local ghost = P_SpawnGhostMobj(player.mo)
				ghost.target = player.mo
				ghost.frame = $&~FF_TRANSMASK
				ghost.frame = $|tr_trans90<<FF_TRANSSHIFT
				if player.ghbag > 1
					if i&1
						ghost.spritexoffset = addr
					else
						ghost.spritexoffset = -addr
					end
				end
				ghost.auragh = true
				ghost.colorized = true
				ghost.blendmode = AST_ADD
				ghost.fuse = 2
			end
			if player.ghbag > 20 --You can get 10 but max is 20
				player.ghbag = 20
			end
		end
		player.throwrock = $ or 0
		player.holdingrock = $ or 0
		player.attacking = $ or 0
		player.stopedge = $ or 0
		player.growrock = $ or 0
		if player.attacking
			player.attacking = $ - 1
			player.nocrouch = 5
			player.friction = FRACUNIT/2*3
			player.pflags = $|PF_FULLSTASIS
			player.mo.state = S_PLAY_WALK
			player.mo.tics = -1
			player.mo.frame = G
			player.attack = true
			if player.speed > FRACUNIT*15 --Extendo punch
				if P_IsObjectOnGround(player.mo)
					player.attacking = 5
				elseif (player.mo.momz == 0 or ((player.mo.momz*P_MobjFlip(player.mo) <= -7*FRACUNIT) and (player.mo.momz*P_MobjFlip(player.mo) >= -8*FRACUNIT)))
					player.attacking = 0
				end
			end
			if not P_IsObjectOnGround(player.mo)
				player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE
			end
			local hit = P_SPMAngle(player.mo, MT_DEMONFIRE, player.drawangle)
			if hit and hit.valid
				hit.momx = player.mo.momx
				hit.momy = player.mo.momy
				hit.momz = player.mo.momz
				hit.fuse = 3
				hit.tics = 3
				hit.knuxpunch = true
				hit.flags2 = $|MF2_DONTDRAW
				hit.height = player.mo.height
				hit.radius = player.mo.radius/2*3
			end
			/*player.pflags = $|PF_SPINNING
			if P_IsObjectOnGround(player.mo)
				player.mo.momx = $/15*14
				player.mo.momy = $/15*14
			end*/
			local goang = player.drawangle
			if player.speed
				goang = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
			else
				goang = $
			end
			player.drawangle = goang
			PunchEffects(player)
		else
			if player.attack
				player.mo.state = S_PLAY_EDGE
				player.stopedge = 5
				player.istop = true
				player.pflags = $&~PF_SPINNING
				player.friction = 29*FRACUNIT/32
				if P_IsObjectOnGround(player.mo)
					player.mo.momx = $/2
					player.mo.momy = $/2
				end
			end
			player.attack = false
		end
		if player.stopedge
			player.stopedge = $-1
			player.istop = true
			if player.mo.state != S_PLAY_EDGE
				player.mo.state = S_PLAY_EDGE
			end
			player.pflags = $|PF_FULLSTASIS
			if not P_IsObjectOnGround(player.mo)
				player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE
			end
		else	
			if player.istop
				player.pflags = $|PF_JUMPSTASIS
				if not P_IsObjectOnGround(player.mo)
					player.mo.state = S_PLAY_FALL
				else
					player.mo.state = S_PLAY_STND
				end
			end
			player.istop = false
		end
		if player.holdingrock
			player.holdingrock = $ - 1
			if player.holdrock and player.holdrock.valid --Hold rock
				player.washolding = true
				if player.diganim
					player.holdrock.spriteyoffset = $-FRACUNIT/3*4
				else
					player.holdrock.spriteyoffset = 0
				end
				local flipheg = player.mo.z+player.mo.height+15*FRACUNIT
				if P_MobjFlip(player.mo) == 1
					flipheg = player.mo.z+player.mo.height+15*FRACUNIT
					player.holdrock.flags2 = $&~MF2_OBJECTFLIP
					player.holdrock.eflags = $&~MFE_VERTICALFLIP
				else
					flipheg = player.mo.z-30*FRACUNIT
					player.holdrock.flags2 = $|MF2_OBJECTFLIP
					player.holdrock.eflags = $|MFE_VERTICALFLIP
				end
				P_TeleportMove(player.holdrock, player.mo.x, player.mo.y, flipheg)
				player.holdrock.momx = player.mo.momx
				player.holdrock.momy = player.mo.momy
				player.holdrock.momz = player.mo.momz
				if player.ghbag
					if player.growrock < player.ghbag*FRACUNIT
						player.growrock = $+FRACUNIT/5
					end
					local multi = player.growrock
					if multi <= 0
						multi = 1
					else
						multi = player.growrock/10
					end
					player.holdrock.scale = FRACUNIT+multi
				else
					player.holdrock.scale = FRACUNIT
					player.holdrock.fuse = TICRATE*5
					player.holdrock.destscale = FRACUNIT/3
					player.holdrock.scalespeed = FRACUNIT/TICRATE/5
				end
				player.holdrock.fuse = TICRATE*5
				if player.crouching
				or player.glidetime
				or player.climbing
				or player.dotheflip
				or player.diganim
					player.holdingrock = 15
				end
				
				local ptarg = P_LookForEnemies(player, false, true) --Lock-on
				if ptarg and ptarg.valid
					P_SpawnLockOn(player, ptarg, S_LOCKON1)
				end
				if not player.nogroundjump --Throw rock
				and (player.cmd.buttons & BT_SPIN)
				and not player.nogroundjump
					player.holdingrock = 0
					if player.dotheflip
						if P_MobjFlip(player.mo) == 1
							player.holdrock.flags2 = $|MF2_OBJECTFLIP
							player.holdrock.eflags = $|MFE_VERTICALFLIP
						else
							player.holdrock.flags2 = $&~MF2_OBJECTFLIP
							player.holdrock.eflags = $&~MFE_VERTICALFLIP
						end
					end
					P_TeleportMove(player.holdrock, player.mo.x, player.mo.y, player.mo.z+player.mo.height/2)
					player.holdrock.flags = $&~MF_SPECIAL
					player.holdrock.state = player.holdrock.info.spawnstate
					player.holdrock.scale = FRACUNIT
					player.holdrock.fuse = TICRATE*5
					player.holdrock.destscale = FRACUNIT/3
					player.holdrock.scalespeed = FRACUNIT/TICRATE/5
					if player.growrock
						local multi = player.growrock
						if multi <= 0
							multi = 1
						else
							multi = player.growrock/10
						end
						player.holdrock.scale = FRACUNIT+multi
						player.holdrock.fuse = TICRATE*5 + ((multi/FRACUNIT)*5)
						player.holdrock.destscale = FRACUNIT/3
						player.holdrock.scalespeed = FRACUNIT/(TICRATE*5 + ((multi/FRACUNIT)*5))
						if player.ghbag
							player.ghbag = $-(player.growrock/FRACUNIT) 
						end
						if multi >= FRACUNIT/4*3
						and multi < (FRACUNIT/4*3)*2
							player.holdrock.damageadd = 1
						elseif multi >= (FRACUNIT/4*3)*2
							player.holdrock.damageadd = 2
						end
					end
					local targ = P_LookForEnemies(player, false, true)
					if targ and targ.valid
						P_ParabolicMove(player.holdrock, targ.x, targ.y, targ.z, 20*FRACUNIT)
					else
						P_InstaThrust(player.holdrock, player.mo.angle, 20*FRACUNIT)
						P_SetObjectMomZ(player.holdrock, 5*FRACUNIT)
					end
					player.nocrouch = 15
					P_Thrust(player.mo, R_PointToAngle2(0, 0, player.holdrock.momx, player.holdrock.momy)+ANGLE_180, 5*FRACUNIT)
					if not player.dotheflip
						P_SetObjectMomZ(player.mo, 5*FRACUNIT, true)
					end
					S_StartSound(player.mo, sfx_wbreak)
					player.throwrock = TICRATE
					player.pleaseplayanim = true
					player.growrock = 0
				end
			end
		else
			if player.washolding
			and player.holdrock and player.holdrock.valid
				if player.dotheflip
					if P_MobjFlip(player.mo) == 1
						player.holdrock.flags2 = $|MF2_OBJECTFLIP
						player.holdrock.eflags = $|MFE_VERTICALFLIP
					else
						player.holdrock.flags2 = $&~MF2_OBJECTFLIP
						player.holdrock.eflags = $&~MFE_VERTICALFLIP
					end
				end
				P_TeleportMove(player.holdrock, player.mo.x, player.mo.y, player.mo.z+player.mo.height/2)
			end
			player.washolding = false
			player.growrock = 0
		end
		if player.throwrock
			player.throwrock = $ - 1
			if player.pleaseplayanim
				player.mo.state = S_PLAY_EDGE
				player.mo.frame = A
				player.mo.tics = -1
				if player.crouching
				and not player.nocrouch
					player.throwrock = 0
					player.pleaseplayanim = true
				end
			end
		else
			if player.pleaseplayanim
				if P_IsObjectOnGround(player.mo)
					player.mo.state = S_PLAY_WALK
				else
					player.mo.state = S_PLAY_FALL
				end
			end
			player.pleaseplayanim = false
		end
		player.nocrouch = $ or 0
		player.dontstopspin = $ or 0
		player.checkdigcd = $ or 0
		if player.checkdigcd
			player.checkdigcd = $ - 1
		end
		if player.dontstopspin
			player.dontstopspin = $ - 1
		end
		if player.nocrouch
			player.nocrouch = $ - 1
		end
		player.nogroundjump = $ or 0
		if player.nogroundjump
			player.nogroundjump = $ - 1
		end
		player.diganim = $ or 0
		player.digwallanim = $ or 0
		player.dropdash = $ or 0
		if player.digwallanim --Digging wall anim
			player.digwallanim = $ - 1
			player.nocrouch = 2
			player.deggin2 = true
			player.mo.momx = 0
			player.mo.momy = 0
			player.mo.momz = 0
			local ghost = P_SpawnGhostMobj(player.mo)
			ghost.fuse = 2
			ghost.blendmode = AST_OVERLAY
			ghost.state = S_PLAY_EDGE
			if (leveltime&10) <= 4
				ghost.mirrored = true
			else
				ghost.mirrored = false
			end
			local addrad = (15*FRACUNIT)-(player.digwallanim*FRACUNIT)
			local addx = P_ReturnThrustX(nil, player.drawangle, addrad)
			local addy = P_ReturnThrustY(nil, player.drawangle, addrad)
			P_TeleportMove(ghost, player.mo.x+addx, player.mo.y+addy, player.mo.z)
			player.deleteghost = ghost
			if player.mo.state != S_PLAY_EDGE
				player.mo.state = S_PLAY_EDGE
			end
			player.powers[pw_flashing] = 1
			if not S_SoundPlaying(player.mo, sfx_mindig)
				S_StartSound(player.mo, sfx_mindig)
			end
			player.pflags = $|PF_FULLSTASIS
			if (leveltime&10) <= 4
				player.mo.mirrored = true
			else
				player.mo.mirrored = false
			end
			player.mo.flags2 = $|MF2_DONTDRAW
			if player.ghbag
				local levang = (player.realtime%360)*ANG1
				for i = 1, player.ghbag
					local addr = FixedMul(player.mo.radius/8, cos(levang))
					
					local ghost = P_SpawnGhostMobj(ghost)
					ghost.target = ghost
					ghost.frame = $&~FF_TRANSMASK
					ghost.frame = $|tr_trans90<<FF_TRANSSHIFT
					if player.ghbag > 1
						if i&1
							ghost.spritexoffset = addr
						else
							ghost.spritexoffset = -addr
						end
					end
					ghost.auragh = true
					ghost.colorized = true
					ghost.blendmode = AST_ADD
					ghost.fuse = 2
				end
			end
		else
			if player.deggin2
			and player.gotodig
				if player.deleteghost and player.deleteghost.valid
					P_KillMobj(player.deleteghost)
				end
				player.mo.flags2 = $ & ~MF2_DONTDRAW
				player.mo.mirrored = false
				player.drawangle = $+ANGLE_180
				player.mo.angle = player.drawangle
				player.pflags = $|PF_JUMPED
				player.pflags = $ & ~PF_THOKKED
				player.nocrouch = 5
				P_TeleportMove(player.mo, player.gotodig.x, player.gotodig.y, player.gotodig.z)
				local dig = P_SpawnMobjFromMobj(player.mo, P_ReturnThrustX(nil, player.drawangle, player.mo.radius-FRACUNIT), 
					P_ReturnThrustY(nil, player.drawangle, player.mo.radius-FRACUNIT), 
					player.mo.height/2, MT_MINUSDIRT)
				dig.flags = $|MF_NOGRAVITY
				dig.renderflags = $|RF_PAPERSPRITE
				dig.angle = player.drawangle+ANGLE_90
				S_StartSound(player.mo, sfx_crumbl)
			end
			player.deggin2 = false
		end
		if player.diganim
			player.diganim = $ - 1
			player.nocrouch = 2
			player.deggin = true
			if player.mo.state != S_PLAY_EDGE
				player.mo.state = S_PLAY_EDGE
			end
			player.powers[pw_flashing] = 1
			if player.gotodig
				P_TryMove(player.mo, player.gotodig.x, player.gotodig.y)
			end
			if not S_SoundPlaying(player.mo, sfx_mindig)
				S_StartSound(player.mo, sfx_mindig)
			end
			player.pflags = $|PF_FULLSTASIS
			if (leveltime&10) <= 4
				player.mo.mirrored = true
			else
				player.mo.mirrored = false
			end
			player.mo.spriteyoffset = $ - (FRACUNIT/3*4)*2
		else
			if player.deggin
			and player.gotodig
				player.notricks = true
				player.mo.mirrored = false
				player.mo.spriteyoffset = 0
				player.mo.state = S_PLAY_GLIDE_LANDING
				player.mo.tics = 10
				player.nocrouch = 10
				player.dotheflip = false
				P_TeleportMove(player.mo, player.gotodig.x, player.gotodig.y, player.gotodig.z)
				for i = 1, 6
					local ranang = ((360/6)*i)*ANG1 + P_RandomRange(-5, 5)*ANG1
					local ranx = P_ReturnThrustX(nil, ranang, player.mo.radius/3)
					local rany = P_ReturnThrustY(nil, ranang, player.mo.radius/3)
							
					local digdig = P_SpawnMobj(player.gotodig.x+ranx, player.gotodig.y+rany, player.gotodig.z, MT_MINUSDIRT)
					if not player.gotodig.flip
						digdig.flags2 = $|MF2_OBJECTFLIP
						digdig.eflags = $|MFE_VERTICALFLIP
					end
				end
				local digsurf = P_SpawnMobj(player.gotodig.x, player.gotodig.y, player.gotodig.z, MT_MINUSDIRT)
				if player.gotodig.extra1
					digsurf.state = S_MINUSDIRT2
					digsurf.tics = TICRATE*10
					digsurf.flags = MF_SCENERY|MF_SPECIAL
					digsurf.digdown = {}
					digsurf.digdown.x = player.gotodig.x
					digsurf.digdown.y = player.gotodig.y
					digsurf.digdown.z = player.gotodig.dig
					player.powers[pw_gravityboots] = 0
					player.dotheflip = false
					player.dontunflip = 0
				else
					player.powers[pw_gravityboots] = 5
					player.dotheflip = true
					player.dontunflip = 15
					player.unfliptrue = 2
				end
				if not player.gotodig.flip
					digsurf.flags2 = $|MF2_OBJECTFLIP
					digsurf.eflags = $|MFE_VERTICALFLIP
				end
				S_StartSound(player.mo, sfx_crumbl)
			end
			player.deggin = false
		end
		if player.pflags & PF_SPINNING
		and player.dontstopspin
		and DoCrouchRoll(player)
			player.dontstopspin = 15
		end
		player.ghostchargecd = $ or 0
		if player.ghostchargecd
			player.ghostchargecd = $ - 1
		end
		player.attacknow = $ or 0
		if player.attacknow
			player.attacknow = $ - 1
			player.youfeck = true
		else
			if player.youfeck
				player.mo.flags = $&~MF_NOGRAVITY
			end
			player.youfeck = false
		end
		player.hasground = $ or 0
		player.homingshot = $ or 0
		player.searchnrg = $ or 0
		if player.searchnrg
		and CanUse(player)
			player.searchnrg = $ - 1
			local addr = P_RandomRange(0, player.mo.radius>>FRACBITS)<<FRACBITS
			local adda = P_RandomRange(0, 360)*ANG1
			local addx = P_ReturnThrustX(nil, adda, addr)
			local addy = P_ReturnThrustY(nil, adda, addr)
			local addz = (P_RandomRange(0, player.mo.height>>FRACBITS)<<FRACBITS)*P_MobjFlip(player.mo)
			local s = P_SpawnMobjFromMobj(player.mo, addx, addy, addz, MT_THOK)
			s.state = S_NIGHTSPARKLE1
			s.tics = 1
			s.fuse = 15
			s.color = player.mo.color
			s.colorized = true
			s.blendmode = AST_ADD
		end
		player.searchcd = $ or 0
		if player.searchcd
			player.searchcd = $ - 1
		end
		player.searchaccident = $ or 0
		player.searchremove = $ or 0
		player.groundslam = $ or 0
		if player.groundslam
			player.groundslam = $ - 1
			player.nocrouch = 5
			player.mo.state = S_PLAY_SWIM
			player.mo.frame = A
			player.pflags = $|PF_THOKKED|PF_JUMPED|PF_SHIELDABILITY
			player.pflags = $&~(PF_NOJUMPDAMAGE)
			P_SetObjectMomZ(player.mo, P_GetMobjGravity(player.mo)*P_MobjFlip(player.mo), true)
			if P_IsObjectOnGround(player.mo)
				player.groundslam = 0
				player.nocrouch = 5
				P_Earthquake(player.mo, player.mo, 500*FRACUNIT)
				P_ResetPlayer(player)
				player.mo.state = S_PLAY_GLIDE_LANDING
				player.pflags = $|PF_STASIS
				if (player.speed > FixedMul(player.runspeed, player.mo.scale))
					player.skidtime = $+player.mo.tics
				end
				player.mo.momx = ((player.mo.momx - player.cmomx)/2) + player.cmomx
				player.mo.momy = ((player.mo.momy - player.cmomy)/2) + player.cmomy
				S_StartSound(player.mo, sfx_s3k49)
				CheckAndCrumble(player.mo, player.mo.subsector.sector)
			end
		end
		if P_IsObjectOnGround(player.mo)
			player.nogroundslam = false
		end
		player.groundjumprockscd = $ or 0
		if player.groundjumprockscd then player.groundjumprockscd = $-1 end
		if player.extrabutton
		and player.cmd.buttons & player.extrabutton --Crouch stuff
			if not P_PlayerInPain(player)
			and not player.exiting
			and not player.nocrouch
			and not player.diganim
			and not player.climbing
			and CanUse(player)
			and ((player.powers[pw_carry] == 9) 
			or (player.powers[pw_carry] == 10)
			or (player.powers[pw_carry] == 0))
				player.height = skins[player.mo.skin].spinheight
				player.mo.state = S_PLAY_GLIDE_LANDING
				player.crouching = true
				player.searchremove = 15
				player.searchaccident = $ + 1
				if player.searchaccident == SEARCHTIME
					local ghost = P_SpawnGhostMobj(player.mo)
					ghost.scale = player.mo.scale/4*5
					ghost.destscale = player.mo.scale
					ghost.fuse = 13
				end
				if R_PointToDist2(0, 0, player.mo.momx, player.mo.momx) > FRACUNIT --Dropspin
				and P_IsObjectOnGround(player.mo)
					P_SpawnSkidDust(player, player.mo.radius, true)
					if DoCrouchRoll(player)
					and (player.mo.eflags & MFE_JUSTHITFLOOR)
					and not player.holdingrock
						player.dospin = true
						player.nocrouch = 20
						player.dontstopspin = 15
						if player.ghbag
							if player.ghbag >= (player.dropdash/FRACUNIT)
								player.ghbag = $-(player.dropdash/FRACUNIT)
							else
								player.ghbag = 0
							end
							P_Thrust(player.mo, player.mo.angle, player.dropdash)
							S_StartSound(player.mo, sfx_zoom)
							for i = 1, player.dropdash/FRACUNIT
								local ranang = (player.mo.angle+ANGLE_180) + P_RandomRange(-15,15)*ANG1
								local ranrad = FixedMul(player.mo.radius*3, FRACUNIT+cos(P_RandomRange(0, 360)*ANG1))
								local addx = P_ReturnThrustX(nil, ranang, ranrad)
								local addy = P_ReturnThrustY(nil, ranang, ranrad)
								
								local b = P_SpawnGhostMobj(player.mo)
								b.state = S_PLAY_WALK
								b.tics = -1
								if P_RandomRange(1, 2) == 1
									b.frame = D
								else
									b.frame = H
								end
								b.blendmode = AST_ADD
								b.fuse = TICRATE
								b.colorized = true
								P_TryMove(b, player.mo.x+addx, player.mo.y+addy)
								b.angle = R_PointToAngle2(b.x, b.y, player.mo.x, player.mo.y)
							end
						end
					end
					player.dropdash = 0
				end
				if R_PointToDist2(0, 0, player.mo.momx, player.mo.momx) > FRACUNIT --Dropdash
				and not P_IsObjectOnGround(player.mo)
					if DoCrouchRoll(player)
					and not player.holdingrock
					and ((not player.dropdash)
					or (player.dropdash and player.dropdash/FRACUNIT < player.ghbag*4))
						player.dropdash = $ + FRACUNIT/5
						if (player.dropdash/FRACUNIT) >= 2
							local dash = P_SpawnGhostMobj(player.mo)
							dash.blendmode = AST_ADD
							dash.state = S_PLAY_ROLL
							dash.colorized = true
							dash.fuse = player.dropdash/FRACUNIT
						end
					end
				end
				if not P_IsObjectOnGround(player.mo) --This can be exploited easily
					player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE
					player.pflags = $ & ~PF_CANCARRY
				else
					player.pflags = $|PF_STASIS
					player.pflags = $ & ~(PF_CANCARRY|PF_JUMPED|PF_NOJUMPDAMAGE)
				end
				if player.dotheflip
				and player.powers[pw_gravityboots]
				and CheckDig(player)
				and CheckDig(player).candig
				and player.dacrouch
				and not player.checkdigcd
				and consoleplayer == player
					player.hasground = $ + 1
					if player.hasground >= TICRATE
						local alart = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_GHOST)
						alart.state = S_ALART1
						alart.fuse = TICRATE
						alart.spriteyoffset = player.mo.height+15*FRACUNIT
						player.checkdigcd = TICRATE*5
					end
				else
					player.hasground = 0
				end
				if not P_IsObjectOnGround(player.mo) --Ground slam
				and not player.groundslam
				and not player.nogroundslam
					if player.cmd.buttons & BT_SPIN
					and player.searchaccident < SEARCHTIME
						if player.cmd.buttons & BT_JUMP
							if not player.groundslammer
								player.groundslam = TICRATE*3
								player.nogroundslam = true
								P_SetObjectMomZ(player.mo, -15*FRACUNIT, true)
								player.mo.state = S_PLAY_GLIDE
								player.mo.frame = A
							end
							player.groundslammer = true
						else
							player.groundslammer = false
						end
					end
				end
				if player.cmd.buttons & BT_SPIN --Ground jump
					if not player.groundjump
					and not player.startjump
					and not player.dotheflip
					and not player.nogroundjump
						if P_IsObjectOnGround(player.mo)
							CheckAndCrumble(player.mo, player.mo.subsector.sector)
							P_SetObjectMomZ(player.mo, 15*FRACUNIT, true)
							local ranstart = player.drawangle+(P_RandomRange(0, 360)*ANG1)
							if not player.groundjumprockscd
								for i = 1, 10
									local iang = ((360/10)*i)*ANG1
									local ranf = ranstart + (iang + P_RandomRange(-5, 5)*ANG1)
									local rock = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_FALLINGROCK)
									rock.target = player.mo
									rock.tracer = player.mo
									rock.flags = MF_MISSILE|MF_BOUNCE|MF_GRENADEBOUNCE
									rock.fuse = TICRATE*2
									rock.knuxrock = true
									rock.color = player.mo.color
									/*if player.ghbag < 10
									and not player.ghostchargecd
										rock.hasghost = true
									end*/
									if gametyperules & GTR_TEAMS
										rock.colorized = true
									end
									rock.destscale = FRACUNIT/3
									rock.scalespeed = P_RandomRange((FRACUNIT/30)>>FRACBITS, (FRACUNIT/20)>>FRACBITS)<<FRACBITS --I LOVE FRACBIT SHIFTING!
									P_InstaThrust(rock, ranf, P_RandomRange((FRACUNIT*5)>>FRACBITS,(FRACUNIT*20)>>FRACBITS)<<FRACBITS)
									P_SetObjectMomZ(rock, P_RandomRange((FRACUNIT*2)>>FRACBITS,(player.mo.radius)>>FRACBITS)<<FRACBITS,true)
									
									local randist = P_RandomRange(FRACUNIT*2>>FRACBITS, (FRACUNIT*10)>>FRACBITS)<<FRACBITS
									P_SpawnMobjFromMobj(player.mo, P_ReturnThrustX(nil, ranf, randist), P_ReturnThrustY(nil, ranf, randist), 0, MT_MINUSDIRT)
								end
								if not (gametyperules & GTR_FRIENDLY)
									player.groundjumprockscd = TICRATE*10
								end
							end
							local rock = P_SpawnMobjFromMobj(player.mo, P_ReturnThrustX(nil, player.drawangle, player.mo.radius), P_ReturnThrustY(nil, player.drawangle, player.mo.radius), 0, MT_FALLINGROCK)
							rock.target = player.mo
							rock.tracer = player.mo
							rock.flags = MF_MISSILE|MF_BOUNCE|MF_GRENADEBOUNCE|MF_SPECIAL
							rock.fuse = TICRATE*5
							rock.knuxrock = true
							rock.color = player.mo.color
							rock.scale = FRACUNIT
							if gametyperules & GTR_TEAMS
								rock.colorized = true
							end
							rock.momx = player.mo.momx
							rock.momy = player.mo.momy
							rock.momz = player.mo.momz
							rock.destscale = FRACUNIT/3
							rock.scalespeed = FRACUNIT/TICRATE/5
							
							S_StartSound(player.mo, sfx_crumbl)
							player.mo.state = S_PLAY_SPRING
							player.nocrouch = 15
							if not player.ghostchargecd
								player.ghostchargecd = TICRATE*5
							end
						elseif ((not player.searchcd) and player.searchaccident >= SEARCHTIME)
							player.searchnrg = TICRATE*30
							player.searchcd = player.searchnrg + TICRATE*10
							for i = 1, 35
								local ranr = P_RandomRange((player.mo.radius*3)>>FRACBITS,(1000*FRACUNIT)>>FRACBITS) <<FRACBITS
								local rana = P_RandomRange(0, 360)*ANG1
								local addx = P_ReturnThrustX(nil, rana, ranr)
								local addy = P_ReturnThrustY(nil, rana, ranr)
								local addz = P_RandomRange(0,(player.mo.height*3)>>FRACBITS)<<FRACBITS --Z Range of the search
								local trail = P_SpawnMobjFromMobj(player.mo, addx, addy, addz, MT_THOK)
								trail.color = player.mo.color
								--trail.target = player.mo
								trail.tracer = player.mo
								trail.blendmode = AST_ADD
								trail.tics = player.searchnrg
								trail.fuse = player.searchnrg
								trail.ghosten = true
								trail.flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SPECIAL
								trail.flags = $&~MF_NOCLIPTHING
								if multiplayer
									if player != consoleplayer
										trail.flags2 = $|MF2_DONTDRAW
										trail.dontsee = true
									end
								else
									if players[0] == player
									and player != displayplayer
										trail.flags2 = $|MF2_DONTDRAW
										trail.dontsee = true
									end
									if players[1] == player
									and player != displayplayer2
										trail.flags2 = $|MF2_DONTDRAW
										trail.dontsee = true
									end
								end
								if not trail.dontsee
									local zoom = P_SpawnMobjFromMobj(trail, 0, 0, (trail.height/2)*P_MobjFlip(trail), MT_THOK)
									zoom.color = trail.color
									zoom.blendmode = AST_ADD
									zoom.spriteyoffset = -43*FRACUNIT/2
									zoom.scale = FRACUNIT*2
									zoom.destscale = FRACUNIT
									zoom.scalespeed = FRACUNIT/15
									S_StartSound(trail, sfx_monton)
								end
							end
						end
					end
					if player.dotheflip --If you kill yourself with this, not my problem
					and not player.groundjump
					and (player.mo.ceilingrover or player.mo.floorrover)
						if CheckDig(player)
						and CheckDig(player).candig
							local digt = CheckDig(player)
							local flipped = false
							for i = 1, 6
								local ranang = ((360/6)*i)*ANG1 + P_RandomRange(-5, 5)*ANG1
								local ranx = P_ReturnThrustX(nil, ranang, player.mo.radius/3)
								local rany = P_ReturnThrustY(nil, ranang, player.mo.radius/3)
							
								local digdig = P_SpawnMobj(player.mo.x+ranx, player.mo.y+rany, digt.dig, MT_MINUSDIRT)
								if P_MobjFlip(player.mo) == -1
									digdig.flags2 = $|MF2_OBJECTFLIP
									digdig.eflags = $|MFE_VERTICALFLIP
								end
							end
							if P_MobjFlip(player.mo) == -1
								flipped = true
							end
							player.gotodig = {
							x = player.mo.x,
							y = player.mo.y,
							z = digt.surf,
							extra1 = true,
							dig = digt.dig,
							flip = flipped}
							player.mo.momx = 0
							player.mo.momy = 0
							player.mo.momz = 0
							player.diganim = 15
						end
					end
					player.groundjump = true
				else
					player.groundjump = false
				end
				player.charability = CA_NONE --https://cdn.discordapp.com/attachments/220988469785133056/1054037545803075654/image.png
			end
			if player.dacrouch --Wall dig
			and not player.exiting
			and not player.nocrouch
			and player.climbing
				local tpto
				local lastfail
				for i = 1, 50
					local addrad = player.mo.radius + ((player.mo.radius)*i)
					local addx = P_ReturnThrustX(nil, player.drawangle, addrad)
					local addy = P_ReturnThrustY(nil, player.drawangle, addrad)
					
					local mo = P_SpawnMobj(player.mo.x+addx, player.mo.y+addy, player.mo.z, MT_THOK)
					mo.radius = player.mo.radius
					mo.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
					mo.flags2 = $|MF2_DONTDRAW
					mo.fuse = 2
					mo.tics = 2
					mo.height = player.mo.height
					
					if CheckDigWall(mo, player.mo)
						tpto = mo
						if lastfail and lastfail.valid --Extra check
							for i = 1, 50
								local radfix = R_PointToDist2(tpto.x, tpto.y, lastfail.x, lastfail.y)/50
								local ranang = R_PointToAngle2(tpto.x, tpto.y, lastfail.x, lastfail.y)
								local radi = radfix*i
								local addxi = P_ReturnThrustX(nil, ranang, radi)
								local addyi = P_ReturnThrustY(nil, ranang, radi)
								local chk = P_SpawnMobj(tpto.x+addxi, tpto.y+addyi, tpto.z, MT_THOK)
								chk.radius = player.mo.radius
								chk.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
								chk.flags2 = $|MF2_DONTDRAW
								chk.fuse = 2
								chk.tics = 2
								chk.height = player.mo.height
								if CheckDigWall(chk, player.mo)
									tpto = chk
								end
							end
						end
						break
					else
						lastfail = mo
					end
				end
				if tpto and tpto.valid --Start digging
					local digspawn
					for i = 1, 50
						local radfix = R_PointToDist2(tpto.x, tpto.y, player.mo.x, player.mo.y)/50
						local ranang = R_PointToAngle2(tpto.x, tpto.y, player.mo.x, player.mo.y)
						local radi = radfix*i
						local addxi = P_ReturnThrustX(nil, ranang, radi)
						local addyi = P_ReturnThrustY(nil, ranang, radi)
						local chk = P_SpawnMobjFromMobj(tpto, addxi, addyi, 0, MT_THOK)
						chk.radius = player.mo.radius
						chk.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
						chk.flags2 = $|MF2_DONTDRAW
						chk.fuse = 2
						chk.tics = 2
						chk.height = player.mo.height
						if CheckDigWall(chk, player.mo)
							digspawn = chk
							break
						end
					end
					if not (digspawn and digspawn.valid)
						digspawn = player.mo
					end
					local dig = P_SpawnMobjFromMobj(digspawn, 
						P_ReturnThrustX(nil, player.drawangle, player.mo.radius-FRACUNIT), 
						P_ReturnThrustY(nil, player.drawangle, player.mo.radius-FRACUNIT), 
						player.mo.height/2, MT_MINUSDIRT)
					if P_MobjFlip(player.mo) == 1
						dig.flags2 = $&~MF2_OBJECTFLIP
						dig.eflags = $&~MFE_VERTICALFLIP
					else
						dig.flags2 = $|MF2_OBJECTFLIP
						dig.eflags = $|MFE_VERTICALFLIP
					end
					dig.flags = $|MF_NOGRAVITY
					dig.renderflags = $|RF_PAPERSPRITE
					dig.angle = player.drawangle+ANGLE_90
					player.gotodig = {
					x = tpto.x,
					y = tpto.y,
					z = tpto.z}
					player.mo.momx = 0
					player.mo.momy = 0
					player.mo.momz = 0
					player.digwallanim = 15
				end
			end
			player.dacrouch = true
		else
			if player.searchremove
				player.searchremove = $ - 1
				player.dotheremoval = true
			else
				if player.dotheremoval
					if player.searchaccident >= SEARCHTIME
						local ghost = P_SpawnGhostMobj(player.mo)
						ghost.scale = player.mo.scale
						ghost.destscale = player.mo.scale/4*5
						ghost.fuse = 13
					end
					player.searchaccident = 0
				end
				player.dotheremoval = false
			end
			player.hasground = 0
			if player.dacrouch
			and player.crouching
				player.crouching = false
				player.nocrouch = 5
				player.charability = CA_GLIDEANDCLIMB --yes i know i could just do 3
				player.height = skins[player.mo.skin].height
				if not P_IsObjectOnGround(player.mo)
					player.pflags = $|PF_JUMPED|PF_NOJUMPDAMAGE
					if player.panim != PA_ABILITY
						player.mo.state = S_PLAY_FALL
					end
				end
				if player.dospin
					player.pflags = $|PF_SPINNING
					player.pflags = $&~PF_STARTDASH
					player.mo.state = S_PLAY_ROLL
					S_StartSound(player.mo, sfx_spin)
				end
			end
			player.dospin = false
			player.dacrouch = false
		end
		
		player.attackcd = $ or 0
		if player.attackcd
			player.attackcd = $ - 1
		end
		if player.cmd.buttons & BT_SPIN --Punch
			if not player.punch
			and not player.crouching
			and not player.attackcd
			and player.speed >= FRACUNIT
			and not player.exiting
			and not player.diganim
			and not player.climbing
			and not player.holdingrock
			and not player.climbing2
			and not player.trickstate
			and CanUse(player)
				/*if (player.powers[pw_shield]
				and P_IsObjectOnGround(player.mo))
				or (not player.powers[pw_shield])*/
					local cmdang = player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove<<16)
					player.attacking = 15
					P_Thrust(player.mo, cmdang, 15*FRACUNIT)
					player.drawangle = cmdang
					player.attackcd = 30
					if player.ghbag
						local targ = FindGhostTargets(player)
						if targ
							player.ptargets = targ
							player.ghbag = $-(#targ)
							for k,v in pairs(targ)
								if v and v.valid
								and v.health
									local ghm = P_SpawnMissile(player.mo, v, MT_DEMONFIRE) 
									if ghm and ghm.valid
										ghm.target = player.mo
										ghm.tracer = v
										ghm.state = S_THOK
										ghm.fuse = TICRATE*10
										ghm.tics = TICRATE*10
										if CBW_Battle
											ghm.tics = 15
											ghm.fuse = 15
										end
										ghm.blendmode = AST_ADD
										ghm.color = player.mo.color
										ghm.ghostmis = true
									end
								end
							end
						end
					end
				//end
			end
			if not player.punch --Grab rock
			and not player.crouching
			and player.speed < FRACUNIT
			and not player.attackcd
			and P_IsObjectOnGround(player.mo)
			and not player.exiting
			and not player.diganim
			and not player.climbing
			and not player.holdingrock
			and not player.climbing2
			and not player.trickstate
			and CanUse(player)
				for i = 1, 6
					local ranang = ((360/6)*i)*ANG1 + P_RandomRange(-5, 5)*ANG1
					local ranx = P_ReturnThrustX(nil, ranang, player.mo.radius/3)
					local rany = P_ReturnThrustY(nil, ranang, player.mo.radius/3)
							
					local digdig = P_SpawnMobjFromMobj(player.mo, ranx, rany, 0, MT_MINUSDIRT)
				end
				local rock = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_FALLINGROCK)
				rock.target = player.mo
				rock.tracer = player.mo
				rock.flags = MF_MISSILE|MF_BOUNCE|MF_GRENADEBOUNCE|MF_SPECIAL
				rock.fuse = TICRATE*5
				rock.knuxrock = true
				rock.color = player.mo.color
				--rock.hasghost = true
				rock.scale = FRACUNIT
				if player.dotheflip
					if P_MobjFlip(player.mo) == 1
						rock.flags2 = $|MF2_OBJECTFLIP
						rock.eflags = $|MFE_VERTICALFLIP
					else
						rock.flags2 = $&~MF2_OBJECTFLIP
						rock.eflags = $&~MFE_VERTICALFLIP
					end
				end
				if gametyperules & GTR_TEAMS
					rock.colorized = true
				end
				P_SetObjectMomZ(rock, FRACUNIT*7, true)
				rock.destscale = FRACUNIT/3
				rock.scalespeed = FRACUNIT/TICRATE/5
							
				S_StartSound(player.mo, sfx_crumbl)
				player.attackcd = TICRATE*2
			end
			player.punch = true
		else	
			player.punch = false
		end
		
		player.dontunflip = $ or 0
		player.unfliptrue = $ or 0
		if player.unfliptrue
			player.unfliptrue = $ - 1
		end
		if player.dontunflip
			player.dontunflip = $ - 1
		end
		player.climbing2 = $ or 0
		if player.climbing2 then player.climbing2 = $-1 end
		if player.climbing --Ceiling climb
		and CanUse(player)
			player.climbing2 = 5
			player.pflags = $|PF_CANCARRY
			local daheight = player.mo.z+player.mo.height
			local dacel = player.mo.ceilingz
			if P_MobjFlip(player.mo) == 1
				daheight = player.mo.z+player.mo.height
				dacel = player.mo.ceilingz
			else
				daheight = player.mo.z
				dacel = player.mo.floorz
			end
			if ((P_MobjFlip(player.mo) == 1 and daheight>=dacel)
			or (P_MobjFlip(player.mo) == -1 and daheight<=dacel))
			and not player.dotheflip
				local reallyflip = true
				if player.mo.subsector
				and player.mo.subsector.sector
				and ((P_MobjFlip(player.mo) == 1 and daheight >= player.mo.subsector.sector.ceilingheight)
				or (P_MobjFlip(player.mo) == -1 and daheight >= player.mo.subsector.sector.floorheight))
				and ((P_MobjFlip(player.mo) == 1 and player.mo.subsector.sector.ceilingpic == "F_SKY1")
				or (P_MobjFlip(player.mo) == -1 and player.mo.subsector.sector.floorpic == "F_SKY1"))
					reallyflip = false
				end
				if reallyflip
					player.powers[pw_gravityboots] = 3 //Who even uses these?
					player.dotheflip = true
					player.dontunflip = 15
					player.unfliptrue = 2
				end
			end
			if player.powers[pw_gravityboots]
			and player.dotheflip
				player.powers[pw_gravityboots] = 20
				player.dontunflip = 20
				player.unfliptrue = 2
				player.dotheflip = true
				player.pflags = $|PF_CANCARRY
				player.flipclimb = true
			end
		elseif player.powers[pw_gravityboots] and player.dotheflip and player.flipclimb
			player.flipclimb = false
			player.mo.momz = FRACUNIT
		end
		if P_IsObjectOnGround(player.mo)
			if player.dotheflip
				player.powers[pw_gravityboots] = 20 //Time to grab wall
				player.dontunflip = 20
				player.unfliptrue = 2
			end
		else
			if CanUnflip(player)
				player.dotheflip = false
				if player.panim != PA_ABILITY
					player.mo.state = S_PLAY_FALL
					player.pflags = $|PF_NOJUMPDAMAGE & ~PF_JUMPED
				end
				player.pflags = $ & ~PF_CANCARRY
				player.powers[pw_gravityboots] = 0
			end
		end
		local function GetTricktype(player)
			if player.trickstype == "never"
				return 0
			end
			if player.trickstype == "springs"
				if ((player.mo.eflags & MFE_SPRUNG)
				and not player.powers[pw_justlaunched])
				or player.springed
					return 1
				else
					return 0
				end
			elseif player.trickstype == "ledges"
				if not P_IsObjectOnGround(player.mo)
				and not player.springed
				and not (player.mo.eflags & MFE_SPRUNG)
				and (not (player.pflags & PF_JUMPED)
				or player.powers[pw_justlaunched])
					return 2
				else
					return 0
				end
			elseif player.trickstype == "always"
				if not P_IsObjectOnGround(player.mo)
				and (not (player.pflags & PF_JUMPED)
				or player.powers[pw_justlaunched]
				or (player.mo.eflags & MFE_SPRUNG)
				or player.springed)
					return 3
				else
					return 0
				end
			end
			return 0
		end
		if P_IsObjectOnGround(player.mo) --Frontiers trick stuff
		or player.powers[pw_carry]
		or (player.pflags & PF_JUMPED)
		or P_PlayerInPain(player)
		or not GetTricktype(player)
		or not CanUse(player)
			player.trickstate = false
			player.trickstate2 = SPR2_FALL
			player.trickanim = 0
			player.stopanim = -1
			player.trickcd = 0
			player.trickcombo = 0
			if player.trickstype == "springs"
				player.springed = false
			end
			player.notricks = false
		end
		player.trickcombo = $ or 0
		player.stopanim = $ or -1
		player.trickanim = $ or 0
		player.starttrick = $ or 0
		player.trickcd = $ or 0
		if player.trickcd then player.trickcd = $-1 end
 		if player.starttrick then player.starttrick = $-1 end
		if player.trickanim
			player.trickanim = $ - 1
			if player.mo.state == S_KNUX_TRICK
				if player.trickstate2
					if player.mo.sprite2 != player.trickstate2
						player.mo.sprite2 = player.trickstate2
					end
				end
				if player.stopanim
				and player.stopanim > 0
					player.mo.frame = player.stopanim-1
				end
			else
				player.mo.state = S_KNUX_TRICK
			end
		end
		local function AlwaysOrLedges(player)
			if not player.climbing
			and not player.glidetime
			and not (player.pflags & PF_THOKKED)
			and not (player.cmd.buttons & BT_JUMP)
			and not (player.cmd.buttons & BT_SPIN)
			and not player.trickstate
			and not P_PlayerInPain(player)
			and player.tricksenabled
			and player.trickstype
			and not player.dotheflip
			and not player.notricks
			and CanUse(player)
			and GetTricktype(player)
				return true
			end
			return false
		end
		if AlwaysOrLedges(player)
		and CanUse(player)
			if (player.mo.eflags & MFE_SPRUNG)
				player.springed = true
			end
			player.trickstate = true
			player.savemom = {
			x = player.mo.momx,
			y = player.mo.momy,
			a = player.drawangle}
			player.trickanim = 2
			if (player.pflags & PF_SPINNING)
				player.starttrick = 15
			else
				player.starttrick = 0
			end
			player.stopanim = -1
			player.trickcd = 0
		end
		
		if player.trickstate
		and player.tricksenabled
		and player.trickstype
		and CanUse(player)
			player.pflags = $|PF_THOKKED & ~PF_SPINNING
			if player.savemom
				--player.mo.momx = player.savemom.x
				--player.mo.momy = player.savemom.y
				if not player.trickanim
					player.drawangle = player.savemom.a
				end
			end
			if player.starttrick
				player.mo.state = S_PLAY_ROLL
			end
			player.nocrouch = 5
			for i = 1, 2
				local addx = P_ReturnThrustX(nil, player.drawangle+ANGLE_90+ANGLE_180*i, player.mo.radius)
				local addy = P_ReturnThrustY(nil, player.drawangle+ANGLE_90+ANGLE_180*i, player.mo.radius)
				local stars = P_SpawnMobjFromMobj(player.mo, addx, addy, (player.mo.height/3*2), MT_THOK)
				stars.state = S_NIGHTSPARKLE1
				stars.tics = TICRATE
				stars.fuse = TICRATE
				stars.color = player.mo.color
				stars.colorized = true
			end
			if (player.mo.eflags & MFE_UNDERWATER)
				P_SetObjectMomZ(player.mo, (-P_GetMobjGravity(player.mo)/4)*P_MobjFlip(player.mo), true)
			else
				P_SetObjectMomZ(player.mo, (-P_GetMobjGravity(player.mo)/2)*P_MobjFlip(player.mo), true)
			end
			if not player.trickanim
			and not player.starttrick
				if player.mo.momz*P_MobjFlip(player.mo) > 0
					if player.mo.state != S_PLAY_SPRING
						player.mo.state = S_PLAY_SPRING
					end
				else
					if player.mo.state != S_PLAY_FALL
						player.mo.state = S_PLAY_FALL
					end
				end
			elseif player.rotang
				player.drawangle = $+(player.rotang*(ANG1*5))
			end
			
			if (player.cmd.buttons & BT_JUMP)
			or (player.cmd.buttons & BT_SPIN)
			or (player.extrabutton and (player.cmd.buttons & player.extrabutton))
				player.trickstate = false
				player.pflags = $|PF_JUMPED
				player.pflags = $&~(PF_THOKKED|PF_NOJUMPDAMAGE)
				player.mo.state = S_PLAY_JUMP
				if (player.cmd.buttons & BT_JUMP) --Only add height if jump is pressed
					if player.mo.momz*P_MobjFlip(player.mo) >= 0
						if (player.mo.eflags & MFE_UNDERWATER)
							P_SetObjectMomZ(player.mo, 6*FRACUNIT, true)
						else
							P_SetObjectMomZ(player.mo, 12*FRACUNIT, true)
						end
					else
						if (player.mo.eflags & MFE_UNDERWATER)
							P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
						else
							P_SetObjectMomZ(player.mo, 12*FRACUNIT, false)
						end
					end
				end
				S_StartSound(player.mo, sfx_hidden)
				if (gametyperules & GTR_FRIENDLY)
					P_AddPlayerScore(player, 100)
				end
				local l = P_SpawnMobjFromMobj(player.mo, 0, 0, (player.mo.height/2), MT_THOK)
				l.target = player.mo
				l.state = S_OILLAMPFLARE
				l.scale = FRACUNIT
				l.destscale = FRACUNIT/2
				l.scalespeed = FRACUNIT/16
				l.blendmode = AST_ADD
				l.fuse = 16
				l.colorized = true
				l.color = player.mo.color
				l.bruhlamp = true
			end
		end
	end
end)

addHook("MobjThinker", function(l) if l and l.valid and l.bruhlamp and l.target and l.target.valid then P_TeleportMove(l,l.target.x,l.target.y,l.target.z+(l.target.height/2)*P_MobjFlip(l)) end end, MT_THOK)

addHook("PreThinkFrame", do --i do the weird again
	for player in players.iterate()
		if player.valid and player.playerstate == PST_LIVE
		and not player.spectator and player.powers[pw_carry] != CR_NIGHTSMODE
		and player.mo.skin == SKIN
			if player.trickstate
			and player.tricksenabled
			and player.trickstype
			and CanUse(player)
				if player.cmd.forwardmove
				and not player.cmd.sidemove
					if (player.cmd.forwardmove >= 25)
					or (player.cmd.forwardmove <= -25)
						if not player.forwtrick
						and not player.trickcd
							DoTrick(player)
						end
						player.forwtrick = true
					else
						player.forwtrick = false
					end
				else
					player.forwtrick = false
				end
				if player.cmd.sidemove
				and not player.cmd.forwardmove
					if (player.cmd.sidemove >= 25)
					or (player.cmd.sidemove <= -25)
						if not player.sidetrick
						and not player.trickcd
							DoTrick(player)
						end
						player.sidetrick = true
					else
						player.sidetrick = false
					end
				else
					player.sidetrick = false
				end
				if player.cmd.forwardmove
				and player.cmd.sidemove
					if ((player.cmd.forwardmove >= 25)
					or (player.cmd.forwardmove <= -25))
					and ((player.cmd.sidemove >= 25)
					or (player.cmd.sidemove <= -25))
						if not player.diagtrick
						and not player.trickcd
							DoTrick(player)
						end
						player.diagtrick = true
					else
						player.diagtrick = false
					end
				else
					player.diagtrick = false
				end
				--In Frontiers the tricks dont actually restrict your movement.
				//player.cmd.forwardmove = 0
				//player.cmd.sidemove = 0
			end
		end
	end
end)

addHook("TouchSpecial", function(mobj, mo) --Grab rock
	if mobj and mobj.valid
	and mobj.knuxrock
		if mo and mo.valid
		and mo.player and mo.player.valid
		and mo.skin == SKIN
			if mo.player.crouching
			and not mo.player.nocrouch
			and CanUse(mo.player, true)
				if not mo.player.holdingrock
					local midheg = mo.z+(mo.height/2)
					P_TeleportMove(mobj, mo.x, mo.y, midheg)
					mobj.scale = FRACUNIT
					mobj.fuse = TICRATE*5
					mo.player.holdingrock = 5
					mo.player.holdrock = mobj
					local grab = P_SpawnGhostMobj(mobj)
					grab.scale = FRACUNIT*2
					grab.destscale = FRACUNIT
					grab.colorized = true
					S_StartSound(mobj, sfx_ngjump)
				end
				return true
			end
			return true
		end
		return true
	end
end, MT_FALLINGROCK)

addHook("MobjThinker", function(mo) --Rock does ghost
	if mo and mo.valid
	and mo.knuxrock
		if (leveltime%5) == 0
			local ghost = P_SpawnGhostMobj(mo)
			ghost.colorized = true
			ghost.scale = mo.scale
			ghost.spriteyoffset = mo.spriteyoffset
			ghost.destscale = FRACUNIT/6
		end
		/*if mo.hasghost
			if mo.fuse < 15
				for i = 1, 6
					local exp = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_PARTICLE)
					exp.flags = $&~MF_NOGRAVITY
					exp.state = S_ROCKCRUMBLEA
					exp.scale = FRACUNIT/2
					exp.destscale = FRACUNIT/15
					exp.scalespeed = FRACUNIT/15
					exp.fuse = 15
					P_InstaThrust(exp, P_RandomRange(0, 360)*ANG1, P_RandomRange(0, 15)*FRACUNIT)
					P_SetObjectMomZ(exp, P_RandomRange(0, 5)*FRACUNIT)
				end
				mo.hasghost = false
				local trail = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
				trail.color = mo.color
				trail.target = mo.target
				trail.blendmode = AST_ADD
				trail.tics = TICRATE*10
				trail.fuse = TICRATE*10
				trail.ghosten = true
				trail.flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SPECIAL
				trail.flags = $&~MF_NOCLIPTHING
				S_StartSound(trail, sfx_corkh)
				S_StartSound(trail, sfx_monton)
				P_KillMobj(mo)
			end
		end*/
	end
end, MT_FALLINGROCK)

addHook("MobjMoveCollide", function(mo, mobj)
	if mo and mo.valid
	and mo.knuxpunch
		if mobj and mobj.valid
		and (mobj.type == MT_SPIKE
		or mobj.type == MT_WALLSPIKE
		or mobj.type == MT_WALLSPIKEBASE)
		and IsInZ(mo, mobj)
			P_KillMobj(mobj)
		end
	end
end, MT_DEMONFIRE)

addHook("MobjThinker", function(mo) --Ghost stuff
	if mo and mo.valid
	and mo.ghostmis
	and mo.target and mo.target.valid
		mo.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
		if mo.tracer and mo.tracer.valid
			mo.flags2 = $|MF2_DONTDRAW
			local zoom = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
			zoom.color = mo.color
			zoom.blendmode = AST_ADD
			zoom.scale = FRACUNIT
			zoom.destscale = FRACUNIT/15
			zoom.scalespeed = FRACUNIT/15
			zoom.fuse = 14
			zoom.tics = 14
			P_FlyTo(mo, mo.tracer.x, mo.tracer.y, mo.tracer.z, FRACUNIT*60)
			if P_AproxDistance(P_AproxDistance(mo.tracer.x-mo.x,mo.tracer.y-mo.y),mo.tracer.z-mo.z) <= 50*FRACUNIT
				local zoom = P_SpawnMobjFromMobj(mo.tracer, 0, 0, 0, MT_THOK)
				zoom.color = mo.color
				zoom.blendmode = AST_ADD
				zoom.scale = FRACUNIT
				zoom.destscale = FRACUNIT*2
				zoom.fuse = 15
				zoom.tics = 15
				P_DamageMobj(mo.tracer, mo, mo.target, 1)
				P_KillMobj(mo)
			end
		else
			mo.ghostmis = false
			local zoom = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
			zoom.color = mo.color
			zoom.blendmode = AST_ADD
			zoom.scale = FRACUNIT
			zoom.destscale = FRACUNIT*2
			zoom.fuse = 15
			zoom.tics = 15
			P_KillMobj(mo)
		end
	end
end, MT_DEMONFIRE)

addHook("MobjThinker", function(mo) --Ghost stuff
	if mo and mo.valid
	and mo.ghosten
		mo.flags = $|MF_NOGRAVITY
		mo.becomecollectable = $ or 0
		if mo.becomecollectable
			mo.becomecollectable = $ - 1
			mo.collectda = true
		else
			if mo.collectda
				if mo.tracer and mo.tracer.valid
					local zoom = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
					zoom.color = mo.color
					zoom.blendmode = AST_ADD
					zoom.scale = FRACUNIT*2
					zoom.destscale = FRACUNIT
					zoom.scalespeed = FRACUNIT/15
					zoom.fuse = 14
					zoom.tics = 14
					mo.dontsee = false
					mo.target = mo.tracer
				end
			end
			mo.collectda = false
		end
		mo.flags2 = $|MF2_DONTDRAW
		if mo.target and mo.target.valid
			P_FlyTo(mo, mo.target.x, mo.target.y, mo.target.z, FRACUNIT*40)
		end
		if mo.fuse < 15
			mo.scale = $-FRACUNIT/15
		else
			local zoom = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
			zoom.color = mo.color
			zoom.blendmode = AST_ADD
			zoom.scale = FRACUNIT
			zoom.destscale = FRACUNIT/15
			zoom.scalespeed = FRACUNIT/15
			zoom.fuse = 14
			zoom.tics = 14
			if mo.dontsee
				zoom.flags2 = $|MF2_DONTDRAW
			end
		end
	end
end, MT_THOK)

addHook("TouchSpecial", function(mobj, mo)
	if mobj and mobj.valid
	and mobj.ghosten
		if mo and mo.valid
		and mo.player and mo.player.valid
		and mobj.target and mobj.target.valid
		and mobj.target == mo
			mo.player.ghbag = $ + 1
			S_StartSound(mobj, sfx_emfind)
			local zoom = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
			zoom.color = mo.color
			zoom.blendmode = AST_ADD
			zoom.scale = FRACUNIT
			zoom.destscale = FRACUNIT*2
			zoom.fuse = 15
			zoom.tics = 15
			return false
		end
		if mo and mo.valid
		and mo.player and mo.player.valid
		and mobj.tracer and mobj.tracer.valid
		and mobj.tracer == mo
			mobj.becomecollectable = 15
			P_FlyTo(mobj, mobj.tracer.x, mobj.tracer.y, mobj.tracer.z, -FRACUNIT*5)
			return true
		end
		return true
	end
end, MT_THOK)

addHook("TouchSpecial", function(mobj, mo) --Dig back
	if mobj and mobj.valid
	and mobj.digdown
		if mo and mo.valid
		and mo.player and mo.player.valid
		and mo.skin == SKIN
			if not mo.player.dotheflip
				if mo.player.crouching
					if mo.player.cmd.buttons & BT_SPIN
						mobj.flags = mobj.info.flags
						for i = 1, 6
							local ranang = ((360/6)*i)*ANG1 + P_RandomRange(-5, 5)*ANG1
							local ranx = P_ReturnThrustX(nil, ranang, mo.radius/3)
							local rany = P_ReturnThrustY(nil, ranang, mo.radius/3)
							
							local digdig = P_SpawnMobj(mobj.x+ranx, mobj.y+rany, mobj.z, MT_MINUSDIRT)
							if P_MobjFlip(mo) == -1
								digdig.flags2 = $|MF2_OBJECTFLIP
								digdig.eflags = $|MFE_VERTICALFLIP
							end
						end
						mo.player.gotodig = {
						x = mobj.digdown.x,
						y = mobj.digdown.y,
						z = mobj.digdown.z,
						extra1 = false,
						flip = flipped}
						mo.momx = 0
						mo.momy = 0
						mo.momz = 0
						mo.player.diganim = 15
						return false
					else
						mo.player.nogroundjump = 3
						return true
					end
				end
			end
		end
		return true
	end
end, MT_MINUSDIRT)

addHook("MobjDamage", function(mo, mobj, src, dmg, dmgtype)
	if mo and mo.valid
	and mo.player and mo.player.valid
	and mo.skin == SKIN
	and not (dmgtype & DMG_DEATHMASK)
		if mobj and mobj.valid
		and mo.player.crouching
		and dmg <= 1
		and IsInZ(mo, mobj)
		and not (mobj.type == MT_SPIKE
		or mobj.type == MT_WALLSPIKE
		or mobj.type == MT_WALLSPIKEBASE)
		and abs(mo.player.drawangle-R_PointToAngle2(
		  mo.x+P_ReturnThrustX(nil, mo.player.drawangle, -mobj.radius), 
		  mo.y+P_ReturnThrustY(nil, mo.player.drawangle, -mobj.radius), 
		  mobj.x+P_ReturnThrustX(nil, mo.player.drawangle, mo.radius), 
		  mobj.y+P_ReturnThrustY(nil, mo.player.drawangle, mo.radius))) <= ANG30
			local cancelback = 1
			if mo.player.ghbag
				cancelback = mo.player.ghbag
			end
			local addspeed = R_PointToDist2(0, 0, mo.momx, mo.momy)
			local dasped = addspeed+mobj.info.speed+5*FRACUNIT
			P_InstaThrust(mobj, mo.player.drawangle, dasped)
			P_Thrust(mo, mo.player.drawangle, (-(mobj.info.speed+5*FRACUNIT))/cancelback)
			return true
		end
		
		if mobj and mobj.valid
		and mo.player.attacking
		and IsInZ(mo, mobj)
		and abs(mo.player.drawangle-R_PointToAngle2(
		  mo.x+P_ReturnThrustX(nil, mo.player.drawangle, -mobj.radius), 
		  mo.y+P_ReturnThrustY(nil, mo.player.drawangle, -mobj.radius), 
		  mobj.x+P_ReturnThrustX(nil, mo.player.drawangle, mo.radius), 
		  mobj.y+P_ReturnThrustY(nil, mo.player.drawangle, mo.radius))) <= ANG30
			return true
		end
		if mo.player.ghbag --Lose ghosts when getting hit
			if mo.player.rings
				if mo.player.ghbag 
				and mo.player.ghbag > 1
					mo.player.ghbag = $/2
				else
					mo.player.ghbag = 0
				end
				local ghost = P_SpawnGhostMobj(mo)
				ghost.colorized = true
				ghost.fuse = TICRATE*2
				ghost.flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
				ghost.blendmode = AST_ADD
				ghost.state = S_PLAY_PAIN
				ghost.color = mo.color
				if (mo.eflags & MFE_UNDERWATER)
					P_SetObjectMomZ(ghost, FixedDiv(10511*FRACUNIT,2600*FRACUNIT), false)
				else
					P_SetObjectMomZ(ghost, FixedDiv(69*FRACUNIT,10*FRACUNIT), false)
				end
				P_InstaThrust(ghost, mo.player.drawangle, -5*FRACUNIT)
			else
				for i = 1, mo.player.ghbag --Do a fancy ghost scatter when dying
					local ghost = P_SpawnGhostMobj(mo)
					ghost.colorized = true
					ghost.fuse = TICRATE*2
					ghost.flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
					ghost.blendmode = AST_ADD
					if (mo.eflags & (MFE_UNDERWATER|MFE_TOUCHWATER))
						ghost.state = S_PLAY_DRWN
					else
						ghost.state = S_PLAY_DEAD
					end
					ghost.color = mo.color
					P_SetObjectMomZ(ghost, 15*FRACUNIT, false)
					local ran1 = FRACUNIT
					local ran2 = FRACUNIT*15
					local ranpow = P_RandomRange(ran1>>FRACBITS, ran2>>FRACBITS) <<FRACBITS
					local ranang = P_RandomRange(0, 360)*ANG1
					P_Thrust(ghost, ranang+(P_RandomRange(-15, 15)*ANG1), ranpow)
				end
				mo.player.ghbag = 0
			end
		end
	end
end, MT_PLAYER)

addHook("MobjDamage", function(mo, mobj, src, dmg, dmgtype)
	if mo and mo.valid
	and not mo.type == MT_PLAYER --Punch nerf on players.
		if mobj and mobj.valid
			if mobj.knuxpunch
				mobj.knuxpunch = false
				P_DamageMobj(mo, mobj, src, 1)
				mo.flags2 = $&~MF2_FRET
				return false
			end
			if mobj.damageadd
				local dmgf = mobj.damageadd
				mobj.damageadd = 0
				P_DamageMobj(mo, mobj, src, dmgf)
				mo.flags2 = $&~MF2_FRET
				return false
			end
		end
	end
end)

addHook("PlayerSpawn", function(player) --Almost all knux`s variables
	if player.valid and not player.spectator 
	and player.powers[pw_carry] != CR_NIGHTSMODE
	and player.mo.skin == SKIN
		player.ghbag = 0
		player.throwrock = 0
		player.holdingrock = 0
		player.attacking = 0
		player.stopedge = $ or 0
		player.istop = false
		player.attack = false
		player.diganim = 0
		player.digwallanim = 0
		player.washolding = false
		player.crouching = false
		player.dotheflip = false
		player.nocrouch = 5
		player.throwrock = 0
		player.pleaseplayanim = false
		player.holdrock = nil
		player.dontstopspin = 0
		player.checkdigcd = 0
		player.nogroundjump = 0
		player.deggin = false
		player.deggin2 = 0
		player.mo.mirrored = false
		player.dontunflip = 0
		player.unfliptrue = 0
		player.dontstopspin = 0
		player.hasground = 0
		player.dospin = false
		player.climbspeed = 0
		player.flipclimb = false
		player.ghostchargecd = 0
		player.ptargets = {}
		player.searchnrg = 0
		player.searchcd = 0
		player.trickcombo = 0
		player.trickstate = false
		player.trickstate2 = SPR2_FALL
		player.trickstart = 0
		player.rotang = 0
		player.savemom = {}
		player.trickanim = 0
		player.stopanim = -1
		player.trickcd = 0
	end
end)